<?php

/**
 * Base class that represents a row from the 'katao_order' table.
 *
 * 
 *
 * @package    lib.model.om
 */
abstract class BaseKataoOrder extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        KataoOrderPeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;


	/**
	 * The value for the katao_supplier_id field.
	 * @var        int
	 */
	protected $katao_supplier_id;


	/**
	 * The value for the katao_period_id field.
	 * @var        int
	 */
	protected $katao_period_id;


	/**
	 * The value for the katao_node_id field.
	 * @var        int
	 */
	protected $katao_node_id;


	/**
	 * The value for the status field.
	 * @var        int
	 */
	protected $status = 1;


	/**
	 * The value for the is_simulated field.
	 * @var        int
	 */
	protected $is_simulated = 0;


	/**
	 * The value for the supplier_name field.
	 * @var        string
	 */
	protected $supplier_name;


	/**
	 * The value for the supplier_email field.
	 * @var        string
	 */
	protected $supplier_email;


	/**
	 * The value for the supplier_address1 field.
	 * @var        string
	 */
	protected $supplier_address1;


	/**
	 * The value for the supplier_address2 field.
	 * @var        string
	 */
	protected $supplier_address2;


	/**
	 * The value for the supplier_zip field.
	 * @var        string
	 */
	protected $supplier_zip;


	/**
	 * The value for the supplier_city field.
	 * @var        string
	 */
	protected $supplier_city;


	/**
	 * The value for the katao_name field.
	 * @var        string
	 */
	protected $katao_name;


	/**
	 * The value for the katao_address field.
	 * @var        string
	 */
	protected $katao_address;


	/**
	 * The value for the katao_siret_number field.
	 * @var        string
	 */
	protected $katao_siret_number;


	/**
	 * The value for the katao_rcs_number field.
	 * @var        string
	 */
	protected $katao_rcs_number;


	/**
	 * The value for the katao_capital field.
	 * @var        int
	 */
	protected $katao_capital;


	/**
	 * The value for the delivery_address field.
	 * @var        string
	 */
	protected $delivery_address;


	/**
	 * The value for the created_at field.
	 * @var        int
	 */
	protected $created_at;


	/**
	 * The value for the updated_at field.
	 * @var        int
	 */
	protected $updated_at;

	/**
	 * @var        KataoSupplier
	 */
	protected $aKataoSupplier;

	/**
	 * @var        KataoPeriod
	 */
	protected $aKataoPeriod;

	/**
	 * @var        KataoNode
	 */
	protected $aKataoNode;

	/**
	 * Collection to store aggregation of collKataoOrderProducts.
	 * @var        array
	 */
	protected $collKataoOrderProducts;

	/**
	 * The criteria used to select the current contents of collKataoOrderProducts.
	 * @var        Criteria
	 */
	protected $lastKataoOrderProductCriteria = null;

	/**
	 * Collection to store aggregation of collKataoSupplierInvoiceOrders.
	 * @var        array
	 */
	protected $collKataoSupplierInvoiceOrders;

	/**
	 * The criteria used to select the current contents of collKataoSupplierInvoiceOrders.
	 * @var        Criteria
	 */
	protected $lastKataoSupplierInvoiceOrderCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [katao_supplier_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoSupplierId()
	{

		return $this->katao_supplier_id;
	}

	/**
	 * Get the [katao_period_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoPeriodId()
	{

		return $this->katao_period_id;
	}

	/**
	 * Get the [katao_node_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoNodeId()
	{

		return $this->katao_node_id;
	}

	/**
	 * Get the [status] column value.
	 * 
	 * @return     int
	 */
	public function getStatus()
	{

		return $this->status;
	}

	/**
	 * Get the [is_simulated] column value.
	 * 
	 * @return     int
	 */
	public function getIsSimulated()
	{

		return $this->is_simulated;
	}

	/**
	 * Get the [supplier_name] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierName()
	{

		return $this->supplier_name;
	}

	/**
	 * Get the [supplier_email] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierEmail()
	{

		return $this->supplier_email;
	}

	/**
	 * Get the [supplier_address1] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierAddress1()
	{

		return $this->supplier_address1;
	}

	/**
	 * Get the [supplier_address2] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierAddress2()
	{

		return $this->supplier_address2;
	}

	/**
	 * Get the [supplier_zip] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierZip()
	{

		return $this->supplier_zip;
	}

	/**
	 * Get the [supplier_city] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierCity()
	{

		return $this->supplier_city;
	}

	/**
	 * Get the [katao_name] column value.
	 * 
	 * @return     string
	 */
	public function getKataoName()
	{

		return $this->katao_name;
	}

	/**
	 * Get the [katao_address] column value.
	 * 
	 * @return     string
	 */
	public function getKataoAddress()
	{

		return $this->katao_address;
	}

	/**
	 * Get the [katao_siret_number] column value.
	 * 
	 * @return     string
	 */
	public function getKataoSiretNumber()
	{

		return $this->katao_siret_number;
	}

	/**
	 * Get the [katao_rcs_number] column value.
	 * 
	 * @return     string
	 */
	public function getKataoRcsNumber()
	{

		return $this->katao_rcs_number;
	}

	/**
	 * Get the [katao_capital] column value.
	 * 
	 * @return     int
	 */
	public function getKataoCapital()
	{

		return $this->katao_capital;
	}

	/**
	 * Get the [delivery_address] column value.
	 * 
	 * @return     string
	 */
	public function getDeliveryAddress()
	{

		return $this->delivery_address;
	}

	/**
	 * Get the [optionally formatted] [created_at] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [updated_at] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->updated_at);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = KataoOrderPeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [katao_supplier_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoSupplierId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_supplier_id !== $v) {
			$this->katao_supplier_id = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_SUPPLIER_ID;
		}

		if ($this->aKataoSupplier !== null && $this->aKataoSupplier->getId() !== $v) {
			$this->aKataoSupplier = null;
		}

	} // setKataoSupplierId()

	/**
	 * Set the value of [katao_period_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoPeriodId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_period_id !== $v) {
			$this->katao_period_id = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_PERIOD_ID;
		}

		if ($this->aKataoPeriod !== null && $this->aKataoPeriod->getId() !== $v) {
			$this->aKataoPeriod = null;
		}

	} // setKataoPeriodId()

	/**
	 * Set the value of [katao_node_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoNodeId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_node_id !== $v) {
			$this->katao_node_id = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_NODE_ID;
		}

		if ($this->aKataoNode !== null && $this->aKataoNode->getId() !== $v) {
			$this->aKataoNode = null;
		}

	} // setKataoNodeId()

	/**
	 * Set the value of [status] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setStatus($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->status !== $v || $v === 1) {
			$this->status = $v;
			$this->modifiedColumns[] = KataoOrderPeer::STATUS;
		}

	} // setStatus()

	/**
	 * Set the value of [is_simulated] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setIsSimulated($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->is_simulated !== $v || $v === 0) {
			$this->is_simulated = $v;
			$this->modifiedColumns[] = KataoOrderPeer::IS_SIMULATED;
		}

	} // setIsSimulated()

	/**
	 * Set the value of [supplier_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_name !== $v) {
			$this->supplier_name = $v;
			$this->modifiedColumns[] = KataoOrderPeer::SUPPLIER_NAME;
		}

	} // setSupplierName()

	/**
	 * Set the value of [supplier_email] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierEmail($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_email !== $v) {
			$this->supplier_email = $v;
			$this->modifiedColumns[] = KataoOrderPeer::SUPPLIER_EMAIL;
		}

	} // setSupplierEmail()

	/**
	 * Set the value of [supplier_address1] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierAddress1($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_address1 !== $v) {
			$this->supplier_address1 = $v;
			$this->modifiedColumns[] = KataoOrderPeer::SUPPLIER_ADDRESS1;
		}

	} // setSupplierAddress1()

	/**
	 * Set the value of [supplier_address2] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierAddress2($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_address2 !== $v) {
			$this->supplier_address2 = $v;
			$this->modifiedColumns[] = KataoOrderPeer::SUPPLIER_ADDRESS2;
		}

	} // setSupplierAddress2()

	/**
	 * Set the value of [supplier_zip] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierZip($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_zip !== $v) {
			$this->supplier_zip = $v;
			$this->modifiedColumns[] = KataoOrderPeer::SUPPLIER_ZIP;
		}

	} // setSupplierZip()

	/**
	 * Set the value of [supplier_city] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierCity($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_city !== $v) {
			$this->supplier_city = $v;
			$this->modifiedColumns[] = KataoOrderPeer::SUPPLIER_CITY;
		}

	} // setSupplierCity()

	/**
	 * Set the value of [katao_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_name !== $v) {
			$this->katao_name = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_NAME;
		}

	} // setKataoName()

	/**
	 * Set the value of [katao_address] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoAddress($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_address !== $v) {
			$this->katao_address = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_ADDRESS;
		}

	} // setKataoAddress()

	/**
	 * Set the value of [katao_siret_number] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoSiretNumber($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_siret_number !== $v) {
			$this->katao_siret_number = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_SIRET_NUMBER;
		}

	} // setKataoSiretNumber()

	/**
	 * Set the value of [katao_rcs_number] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoRcsNumber($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_rcs_number !== $v) {
			$this->katao_rcs_number = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_RCS_NUMBER;
		}

	} // setKataoRcsNumber()

	/**
	 * Set the value of [katao_capital] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoCapital($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_capital !== $v) {
			$this->katao_capital = $v;
			$this->modifiedColumns[] = KataoOrderPeer::KATAO_CAPITAL;
		}

	} // setKataoCapital()

	/**
	 * Set the value of [delivery_address] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setDeliveryAddress($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->delivery_address !== $v) {
			$this->delivery_address = $v;
			$this->modifiedColumns[] = KataoOrderPeer::DELIVERY_ADDRESS;
		}

	} // setDeliveryAddress()

	/**
	 * Set the value of [created_at] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = KataoOrderPeer::CREATED_AT;
		}

	} // setCreatedAt()

	/**
	 * Set the value of [updated_at] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = KataoOrderPeer::UPDATED_AT;
		}

	} // setUpdatedAt()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param      int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->katao_supplier_id = $rs->getInt($startcol + 1);

			$this->katao_period_id = $rs->getInt($startcol + 2);

			$this->katao_node_id = $rs->getInt($startcol + 3);

			$this->status = $rs->getInt($startcol + 4);

			$this->is_simulated = $rs->getInt($startcol + 5);

			$this->supplier_name = $rs->getString($startcol + 6);

			$this->supplier_email = $rs->getString($startcol + 7);

			$this->supplier_address1 = $rs->getString($startcol + 8);

			$this->supplier_address2 = $rs->getString($startcol + 9);

			$this->supplier_zip = $rs->getString($startcol + 10);

			$this->supplier_city = $rs->getString($startcol + 11);

			$this->katao_name = $rs->getString($startcol + 12);

			$this->katao_address = $rs->getString($startcol + 13);

			$this->katao_siret_number = $rs->getString($startcol + 14);

			$this->katao_rcs_number = $rs->getString($startcol + 15);

			$this->katao_capital = $rs->getInt($startcol + 16);

			$this->delivery_address = $rs->getString($startcol + 17);

			$this->created_at = $rs->getTimestamp($startcol + 18, null);

			$this->updated_at = $rs->getTimestamp($startcol + 19, null);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 20; // 20 = KataoOrderPeer::NUM_COLUMNS - KataoOrderPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating KataoOrder object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      Connection $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrder:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoOrderPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			KataoOrderPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseKataoOrder:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoOrder:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(KataoOrderPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(KataoOrderPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoOrderPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseKataoOrder:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoSupplier !== null) {
				if ($this->aKataoSupplier->isModified()) {
					$affectedRows += $this->aKataoSupplier->save($con);
				}
				$this->setKataoSupplier($this->aKataoSupplier);
			}

			if ($this->aKataoPeriod !== null) {
				if ($this->aKataoPeriod->isModified()) {
					$affectedRows += $this->aKataoPeriod->save($con);
				}
				$this->setKataoPeriod($this->aKataoPeriod);
			}

			if ($this->aKataoNode !== null) {
				if ($this->aKataoNode->isModified()) {
					$affectedRows += $this->aKataoNode->save($con);
				}
				$this->setKataoNode($this->aKataoNode);
			}


			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = KataoOrderPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += KataoOrderPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collKataoOrderProducts !== null) {
				foreach($this->collKataoOrderProducts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collKataoSupplierInvoiceOrders !== null) {
				foreach($this->collKataoSupplierInvoiceOrders as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoSupplier !== null) {
				if (!$this->aKataoSupplier->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoSupplier->getValidationFailures());
				}
			}

			if ($this->aKataoPeriod !== null) {
				if (!$this->aKataoPeriod->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoPeriod->getValidationFailures());
				}
			}

			if ($this->aKataoNode !== null) {
				if (!$this->aKataoNode->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoNode->getValidationFailures());
				}
			}


			if (($retval = KataoOrderPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collKataoOrderProducts !== null) {
					foreach($this->collKataoOrderProducts as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collKataoSupplierInvoiceOrders !== null) {
					foreach($this->collKataoSupplierInvoiceOrders as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoOrderPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getKataoSupplierId();
				break;
			case 2:
				return $this->getKataoPeriodId();
				break;
			case 3:
				return $this->getKataoNodeId();
				break;
			case 4:
				return $this->getStatus();
				break;
			case 5:
				return $this->getIsSimulated();
				break;
			case 6:
				return $this->getSupplierName();
				break;
			case 7:
				return $this->getSupplierEmail();
				break;
			case 8:
				return $this->getSupplierAddress1();
				break;
			case 9:
				return $this->getSupplierAddress2();
				break;
			case 10:
				return $this->getSupplierZip();
				break;
			case 11:
				return $this->getSupplierCity();
				break;
			case 12:
				return $this->getKataoName();
				break;
			case 13:
				return $this->getKataoAddress();
				break;
			case 14:
				return $this->getKataoSiretNumber();
				break;
			case 15:
				return $this->getKataoRcsNumber();
				break;
			case 16:
				return $this->getKataoCapital();
				break;
			case 17:
				return $this->getDeliveryAddress();
				break;
			case 18:
				return $this->getCreatedAt();
				break;
			case 19:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoOrderPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getKataoSupplierId(),
			$keys[2] => $this->getKataoPeriodId(),
			$keys[3] => $this->getKataoNodeId(),
			$keys[4] => $this->getStatus(),
			$keys[5] => $this->getIsSimulated(),
			$keys[6] => $this->getSupplierName(),
			$keys[7] => $this->getSupplierEmail(),
			$keys[8] => $this->getSupplierAddress1(),
			$keys[9] => $this->getSupplierAddress2(),
			$keys[10] => $this->getSupplierZip(),
			$keys[11] => $this->getSupplierCity(),
			$keys[12] => $this->getKataoName(),
			$keys[13] => $this->getKataoAddress(),
			$keys[14] => $this->getKataoSiretNumber(),
			$keys[15] => $this->getKataoRcsNumber(),
			$keys[16] => $this->getKataoCapital(),
			$keys[17] => $this->getDeliveryAddress(),
			$keys[18] => $this->getCreatedAt(),
			$keys[19] => $this->getUpdatedAt(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoOrderPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setKataoSupplierId($value);
				break;
			case 2:
				$this->setKataoPeriodId($value);
				break;
			case 3:
				$this->setKataoNodeId($value);
				break;
			case 4:
				$this->setStatus($value);
				break;
			case 5:
				$this->setIsSimulated($value);
				break;
			case 6:
				$this->setSupplierName($value);
				break;
			case 7:
				$this->setSupplierEmail($value);
				break;
			case 8:
				$this->setSupplierAddress1($value);
				break;
			case 9:
				$this->setSupplierAddress2($value);
				break;
			case 10:
				$this->setSupplierZip($value);
				break;
			case 11:
				$this->setSupplierCity($value);
				break;
			case 12:
				$this->setKataoName($value);
				break;
			case 13:
				$this->setKataoAddress($value);
				break;
			case 14:
				$this->setKataoSiretNumber($value);
				break;
			case 15:
				$this->setKataoRcsNumber($value);
				break;
			case 16:
				$this->setKataoCapital($value);
				break;
			case 17:
				$this->setDeliveryAddress($value);
				break;
			case 18:
				$this->setCreatedAt($value);
				break;
			case 19:
				$this->setUpdatedAt($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoOrderPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setKataoSupplierId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setKataoPeriodId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setKataoNodeId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setStatus($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setIsSimulated($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setSupplierName($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setSupplierEmail($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setSupplierAddress1($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setSupplierAddress2($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setSupplierZip($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setSupplierCity($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setKataoName($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setKataoAddress($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setKataoSiretNumber($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setKataoRcsNumber($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setKataoCapital($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setDeliveryAddress($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setCreatedAt($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setUpdatedAt($arr[$keys[19]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(KataoOrderPeer::DATABASE_NAME);

		if ($this->isColumnModified(KataoOrderPeer::ID)) $criteria->add(KataoOrderPeer::ID, $this->id);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_SUPPLIER_ID)) $criteria->add(KataoOrderPeer::KATAO_SUPPLIER_ID, $this->katao_supplier_id);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_PERIOD_ID)) $criteria->add(KataoOrderPeer::KATAO_PERIOD_ID, $this->katao_period_id);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_NODE_ID)) $criteria->add(KataoOrderPeer::KATAO_NODE_ID, $this->katao_node_id);
		if ($this->isColumnModified(KataoOrderPeer::STATUS)) $criteria->add(KataoOrderPeer::STATUS, $this->status);
		if ($this->isColumnModified(KataoOrderPeer::IS_SIMULATED)) $criteria->add(KataoOrderPeer::IS_SIMULATED, $this->is_simulated);
		if ($this->isColumnModified(KataoOrderPeer::SUPPLIER_NAME)) $criteria->add(KataoOrderPeer::SUPPLIER_NAME, $this->supplier_name);
		if ($this->isColumnModified(KataoOrderPeer::SUPPLIER_EMAIL)) $criteria->add(KataoOrderPeer::SUPPLIER_EMAIL, $this->supplier_email);
		if ($this->isColumnModified(KataoOrderPeer::SUPPLIER_ADDRESS1)) $criteria->add(KataoOrderPeer::SUPPLIER_ADDRESS1, $this->supplier_address1);
		if ($this->isColumnModified(KataoOrderPeer::SUPPLIER_ADDRESS2)) $criteria->add(KataoOrderPeer::SUPPLIER_ADDRESS2, $this->supplier_address2);
		if ($this->isColumnModified(KataoOrderPeer::SUPPLIER_ZIP)) $criteria->add(KataoOrderPeer::SUPPLIER_ZIP, $this->supplier_zip);
		if ($this->isColumnModified(KataoOrderPeer::SUPPLIER_CITY)) $criteria->add(KataoOrderPeer::SUPPLIER_CITY, $this->supplier_city);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_NAME)) $criteria->add(KataoOrderPeer::KATAO_NAME, $this->katao_name);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_ADDRESS)) $criteria->add(KataoOrderPeer::KATAO_ADDRESS, $this->katao_address);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_SIRET_NUMBER)) $criteria->add(KataoOrderPeer::KATAO_SIRET_NUMBER, $this->katao_siret_number);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_RCS_NUMBER)) $criteria->add(KataoOrderPeer::KATAO_RCS_NUMBER, $this->katao_rcs_number);
		if ($this->isColumnModified(KataoOrderPeer::KATAO_CAPITAL)) $criteria->add(KataoOrderPeer::KATAO_CAPITAL, $this->katao_capital);
		if ($this->isColumnModified(KataoOrderPeer::DELIVERY_ADDRESS)) $criteria->add(KataoOrderPeer::DELIVERY_ADDRESS, $this->delivery_address);
		if ($this->isColumnModified(KataoOrderPeer::CREATED_AT)) $criteria->add(KataoOrderPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(KataoOrderPeer::UPDATED_AT)) $criteria->add(KataoOrderPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(KataoOrderPeer::DATABASE_NAME);

		$criteria->add(KataoOrderPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of KataoOrder (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setKataoSupplierId($this->katao_supplier_id);

		$copyObj->setKataoPeriodId($this->katao_period_id);

		$copyObj->setKataoNodeId($this->katao_node_id);

		$copyObj->setStatus($this->status);

		$copyObj->setIsSimulated($this->is_simulated);

		$copyObj->setSupplierName($this->supplier_name);

		$copyObj->setSupplierEmail($this->supplier_email);

		$copyObj->setSupplierAddress1($this->supplier_address1);

		$copyObj->setSupplierAddress2($this->supplier_address2);

		$copyObj->setSupplierZip($this->supplier_zip);

		$copyObj->setSupplierCity($this->supplier_city);

		$copyObj->setKataoName($this->katao_name);

		$copyObj->setKataoAddress($this->katao_address);

		$copyObj->setKataoSiretNumber($this->katao_siret_number);

		$copyObj->setKataoRcsNumber($this->katao_rcs_number);

		$copyObj->setKataoCapital($this->katao_capital);

		$copyObj->setDeliveryAddress($this->delivery_address);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getKataoOrderProducts() as $relObj) {
				$copyObj->addKataoOrderProduct($relObj->copy($deepCopy));
			}

			foreach($this->getKataoSupplierInvoiceOrders() as $relObj) {
				$copyObj->addKataoSupplierInvoiceOrder($relObj->copy($deepCopy));
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     KataoOrder Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     KataoOrderPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new KataoOrderPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a KataoSupplier object.
	 *
	 * @param      KataoSupplier $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoSupplier($v)
	{


		if ($v === null) {
			$this->setKataoSupplierId(NULL);
		} else {
			$this->setKataoSupplierId($v->getId());
		}


		$this->aKataoSupplier = $v;
	}


	/**
	 * Get the associated KataoSupplier object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoSupplier The associated KataoSupplier object.
	 * @throws     PropelException
	 */
	public function getKataoSupplier($con = null)
	{
		if ($this->aKataoSupplier === null && ($this->katao_supplier_id !== null)) {
			// include the related Peer class
			$this->aKataoSupplier = KataoSupplierPeer::retrieveByPK($this->katao_supplier_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoSupplierPeer::retrieveByPK($this->katao_supplier_id, $con);
			   $obj->addKataoSuppliers($this);
			 */
		}
		return $this->aKataoSupplier;
	}

	/**
	 * Declares an association between this object and a KataoPeriod object.
	 *
	 * @param      KataoPeriod $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoPeriod($v)
	{


		if ($v === null) {
			$this->setKataoPeriodId(NULL);
		} else {
			$this->setKataoPeriodId($v->getId());
		}


		$this->aKataoPeriod = $v;
	}


	/**
	 * Get the associated KataoPeriod object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoPeriod The associated KataoPeriod object.
	 * @throws     PropelException
	 */
	public function getKataoPeriod($con = null)
	{
		if ($this->aKataoPeriod === null && ($this->katao_period_id !== null)) {
			// include the related Peer class
			$this->aKataoPeriod = KataoPeriodPeer::retrieveByPK($this->katao_period_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoPeriodPeer::retrieveByPK($this->katao_period_id, $con);
			   $obj->addKataoPeriods($this);
			 */
		}
		return $this->aKataoPeriod;
	}

	/**
	 * Declares an association between this object and a KataoNode object.
	 *
	 * @param      KataoNode $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoNode($v)
	{


		if ($v === null) {
			$this->setKataoNodeId(NULL);
		} else {
			$this->setKataoNodeId($v->getId());
		}


		$this->aKataoNode = $v;
	}


	/**
	 * Get the associated KataoNode object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoNode The associated KataoNode object.
	 * @throws     PropelException
	 */
	public function getKataoNode($con = null)
	{
		if ($this->aKataoNode === null && ($this->katao_node_id !== null)) {
			// include the related Peer class
			$this->aKataoNode = KataoNodePeer::retrieveByPK($this->katao_node_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoNodePeer::retrieveByPK($this->katao_node_id, $con);
			   $obj->addKataoNodes($this);
			 */
		}
		return $this->aKataoNode;
	}

	/**
	 * Temporary storage of collKataoOrderProducts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return     void
	 */
	public function initKataoOrderProducts()
	{
		if ($this->collKataoOrderProducts === null) {
			$this->collKataoOrderProducts = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoOrder has previously
	 * been saved, it will retrieve related KataoOrderProducts from storage.
	 * If this KataoOrder is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param      Connection $con
	 * @param      Criteria $criteria
	 * @throws     PropelException
	 */
	public function getKataoOrderProducts($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoOrderProducts === null) {
			if ($this->isNew()) {
			   $this->collKataoOrderProducts = array();
			} else {

				$criteria->add(KataoOrderProductPeer::KATAO_ORDER_ID, $this->getId());

				KataoOrderProductPeer::addSelectColumns($criteria);
				$this->collKataoOrderProducts = KataoOrderProductPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(KataoOrderProductPeer::KATAO_ORDER_ID, $this->getId());

				KataoOrderProductPeer::addSelectColumns($criteria);
				if (!isset($this->lastKataoOrderProductCriteria) || !$this->lastKataoOrderProductCriteria->equals($criteria)) {
					$this->collKataoOrderProducts = KataoOrderProductPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastKataoOrderProductCriteria = $criteria;
		return $this->collKataoOrderProducts;
	}

	/**
	 * Returns the number of related KataoOrderProducts.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      Connection $con
	 * @throws     PropelException
	 */
	public function countKataoOrderProducts($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(KataoOrderProductPeer::KATAO_ORDER_ID, $this->getId());

		return KataoOrderProductPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a KataoOrderProduct object to this object
	 * through the KataoOrderProduct foreign key attribute
	 *
	 * @param      KataoOrderProduct $l KataoOrderProduct
	 * @return     void
	 * @throws     PropelException
	 */
	public function addKataoOrderProduct(KataoOrderProduct $l)
	{
		$this->collKataoOrderProducts[] = $l;
		$l->setKataoOrder($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoOrder is new, it will return
	 * an empty collection; or if this KataoOrder has previously
	 * been saved, it will retrieve related KataoOrderProducts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoOrder.
	 */
	public function getKataoOrderProductsJoinKataoProduct($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoOrderProducts === null) {
			if ($this->isNew()) {
				$this->collKataoOrderProducts = array();
			} else {

				$criteria->add(KataoOrderProductPeer::KATAO_ORDER_ID, $this->getId());

				$this->collKataoOrderProducts = KataoOrderProductPeer::doSelectJoinKataoProduct($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoOrderProductPeer::KATAO_ORDER_ID, $this->getId());

			if (!isset($this->lastKataoOrderProductCriteria) || !$this->lastKataoOrderProductCriteria->equals($criteria)) {
				$this->collKataoOrderProducts = KataoOrderProductPeer::doSelectJoinKataoProduct($criteria, $con);
			}
		}
		$this->lastKataoOrderProductCriteria = $criteria;

		return $this->collKataoOrderProducts;
	}

	/**
	 * Temporary storage of collKataoSupplierInvoiceOrders to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return     void
	 */
	public function initKataoSupplierInvoiceOrders()
	{
		if ($this->collKataoSupplierInvoiceOrders === null) {
			$this->collKataoSupplierInvoiceOrders = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoOrder has previously
	 * been saved, it will retrieve related KataoSupplierInvoiceOrders from storage.
	 * If this KataoOrder is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param      Connection $con
	 * @param      Criteria $criteria
	 * @throws     PropelException
	 */
	public function getKataoSupplierInvoiceOrders($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoSupplierInvoiceOrders === null) {
			if ($this->isNew()) {
			   $this->collKataoSupplierInvoiceOrders = array();
			} else {

				$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_ORDER_ID, $this->getId());

				KataoSupplierInvoiceOrderPeer::addSelectColumns($criteria);
				$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_ORDER_ID, $this->getId());

				KataoSupplierInvoiceOrderPeer::addSelectColumns($criteria);
				if (!isset($this->lastKataoSupplierInvoiceOrderCriteria) || !$this->lastKataoSupplierInvoiceOrderCriteria->equals($criteria)) {
					$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastKataoSupplierInvoiceOrderCriteria = $criteria;
		return $this->collKataoSupplierInvoiceOrders;
	}

	/**
	 * Returns the number of related KataoSupplierInvoiceOrders.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      Connection $con
	 * @throws     PropelException
	 */
	public function countKataoSupplierInvoiceOrders($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_ORDER_ID, $this->getId());

		return KataoSupplierInvoiceOrderPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a KataoSupplierInvoiceOrder object to this object
	 * through the KataoSupplierInvoiceOrder foreign key attribute
	 *
	 * @param      KataoSupplierInvoiceOrder $l KataoSupplierInvoiceOrder
	 * @return     void
	 * @throws     PropelException
	 */
	public function addKataoSupplierInvoiceOrder(KataoSupplierInvoiceOrder $l)
	{
		$this->collKataoSupplierInvoiceOrders[] = $l;
		$l->setKataoOrder($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoOrder is new, it will return
	 * an empty collection; or if this KataoOrder has previously
	 * been saved, it will retrieve related KataoSupplierInvoiceOrders from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoOrder.
	 */
	public function getKataoSupplierInvoiceOrdersJoinKataoSupplierInvoice($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoSupplierInvoiceOrders === null) {
			if ($this->isNew()) {
				$this->collKataoSupplierInvoiceOrders = array();
			} else {

				$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_ORDER_ID, $this->getId());

				$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelectJoinKataoSupplierInvoice($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_ORDER_ID, $this->getId());

			if (!isset($this->lastKataoSupplierInvoiceOrderCriteria) || !$this->lastKataoSupplierInvoiceOrderCriteria->equals($criteria)) {
				$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelectJoinKataoSupplierInvoice($criteria, $con);
			}
		}
		$this->lastKataoSupplierInvoiceOrderCriteria = $criteria;

		return $this->collKataoSupplierInvoiceOrders;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseKataoOrder:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseKataoOrder::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseKataoOrder
